declare type Choice<T = string> = {
    title: string;
    description?: string;
    value: T;
    disabled?: boolean;
};
declare type Option<T extends Type = Type> = T extends 'confirm' ? OptionConfirm : T extends 'number' ? OptionNumber : T extends 'auto' | 'multi' | 'select' ? OptionSelect : T extends 'text' ? OptionText : T extends 'toggle' ? OptionToggle : never;
declare type OptionConfirm = OptionGeneral & {
    type: 'confirm';
    default?: boolean;
};
declare type OptionGeneral = {
    type: Type;
    id?: string;
    message?: string;
};
declare type OptionNumber = OptionGeneral & {
    type: 'number';
    default?: number;
    max: number;
    min: number;
};
declare type OptionSelect = OptionGeneral & {
    type: 'auto' | 'multi' | 'select';
    default?: number | string;
    list: string[] | Choice[];
};
declare type OptionText = OptionGeneral & {
    type: 'text';
    default?: string;
};
declare type OptionToggle = OptionGeneral & {
    type: 'toggle';
    default?: boolean;
    off?: string;
    on?: string;
};
declare type Result<T extends Type = Type> = T extends 'confirm' ? boolean : T extends 'number' ? number : T extends 'auto' | 'multi' | 'select' ? string : T extends 'text' ? string : T extends 'toggle' ? boolean : never;
declare type Type = typeof listType[number];
declare const listType: readonly ["auto", "confirm", "multi", "number", "select", "text", "toggle"];
declare const main: <T = void, U extends "number" | "auto" | "toggle" | "select" | "text" | "confirm" | "multi" = "number" | "auto" | "toggle" | "select" | "text" | "confirm" | "multi">(option: Option<U> & {
    type: U;
}) => Promise<T extends void ? Result<U> : T>;
export default main;
